function [ros,bn,dn,sn,tn,jn,an]=diagnos(preder,n0,r);
%input preder  pred. errors
%      n0      summation start for moments
%      r      number of autocorrelations
%plot the EDF of u_t, normal plot of transf. P-scores, autocorrelogram of transf. P-scores
% and of transf. reflected P-scores, and calculate diagnostics
ut=preder(n0:end,:);
utrefl=2*abs(preder-0.5);
nw = size(ut,2);
N = size(ut,1);

ros=[];bn=[];dn=[];sn=[];tn=[];jn=[];an=[];
%Rosenblatt
%ncells=100;
%C = zeros(ncells,ncells,ncells);
%x=reshape(ut',nw,1,N);
%p=cumsum(ones(ncells,1)/ncells)';
%jind = squeeze(sum([p(ones(nw,1),:,ones(N,1)) < x(:,ones(1,ncells),:)],2) + 1);
%for i=jind;
%   C(i(1),i(2),i(3))=C(i(1),i(2),i(3))+1;
%end;   
%C=((C-N/(ncells^nw)).^2)/(N/(ncells^nw));
%ros=sum(reshape(C,ncells^nw,1));

%EDF of P-scores
utsort=sort(ut,1);
edf=[0:1/(N-1):1.0];
%figure(1);
%plot(edf',edf','-',edf',utsort(:,1),'x');

%P-scores
vt=erfinv(ut*2-1)*sqrt(2);
vtrefl=erfinv(utrefl*2-1)*sqrt(2);
vtsort=sort(vt);
ord=([1:N]'-0.5)/N;
ordstat=erfinv(ord*2-1)*sqrt(2);
%figure(2);
%plot(vtsort(:,1),vtsort(:,1),'-',vtsort(:,1),ordstat,'x');

%autocorrelations
[ac1, hm, sd, ki, ineff] = autocovneu(vt,r);
[ac2, hm, sd, ki, ineff] = autocovneu(vtrefl,r);
ki=[ones(r,1)*(-2/sqrt(N)) ones(r,1)*2/sqrt(N)];
%figure(3);
%plot([ac(:,1) ki]);
%axis([0 r+1 -1 1]);
%statistics
m1=mean(vt,1);
m2=sum([(vt-m1(ones(N,1),:)).^2],1)/N;
m3=sum([(vt-m1(ones(N,1),:)).^3],1)/N;
m4=sum([(vt-m1(ones(N,1),:)).^4],1)/N;

bn=sqrt(N)*m1;
dn=(N*m2-N+1)/sqrt(2*(N-1));
sn=sqrt(((N+1)*(N+3))/(6*(N-2)))*m3./sqrt(m2.^3);
tn=(N+1)*sqrt((N+3)*(N+5))/sqrt(24*(N-2)*(N-3)*N)*(m4./(m2.^2)-3*(N-1)/(N+1));
jn=sn.^2+tn.^2;
an=sqrt(N)*(ac1(1,:)+1/(N-1));

figure(1)
for i = 1:nw
subplot(2,2,1+4*(i-1));
plot(edf',edf','-',edf',utsort(:,i),'x');
subplot(2,2,2+4*(i-1));
plot(vtsort(:,i),vtsort(:,i),'-',vtsort(:,i),ordstat,'x');
axis([-3 3 -3 3]);
subplot(2,2,3+4*(i-1));
plot([ac1(:,i) ki]);
axis([1 r -0.5 0.5]);
subplot(2,2,4+4*(i-1));
plot([ac2(:,i) ki]);
axis([1 r -0.5 0.5]);
end
subplot(2,2,1);
title('edf');
subplot(2,2,2);
title('normal plot');
subplot(2,2,3);
title('correlogram of transf. P-scores');
subplot(2,2,4);
title('corr. of transformed refl. P-scores');
%figure(2);
%nst=size(gammasim,1);
%for i=1:nst
%   subplot(nst,1,i);
%   plot(gammasim(i,:));
%end
%subplot(nst,1,1);
%title('gammasim');

