function [loglikq,loglikmc,priorq,priormc,qq,qmc,qnormarch] = mlbs_ql(y,lags,e0,alxi0,prgamma,prbem,prbeinf,betamcmc,gammamcmc,ximcmc,alphamcmc,etamcmc,etapost,betapostm,betapostchol,archpostm,archpostchol,loglikmc,it0,L)

% bridge sampling estimators: random permuations  from MCMC sample of size MMC 

n=size(y,1);
index=[];for i=1:lags;index=[index;lags-i+1:n-i];end;index=index';
Z=[ones(n-lags,1) y(index)];
y=y(lags+1:end);

mc=size(gammamcmc,2); %  laenge MCMC sample
if L < mc
   % zufllige auswahl der MCMC simulationen
u = simuni(mc,L);
betamcmc=betamcmc(:,u);
etamcmc=etamcmc(:,:,u);
alphamcmc=alphamcmc(:,u);
gammamcmc=gammamcmc(:,u);
ximcmc=ximcmc(u);
loglikmc=loglikmc(u);
end

M=L;      % laenge q sample
MMC=size(archpostchol,3);  % laenge der mixture

nst = size(gammamcmc,1);
etasim = ones(nst,nst,L);
betasize=size(betamcmc,1);
betasim = zeros(betasize,L);
march=size(alphamcmc,1); %leverage
archsize=march+size(gammamcmc,1)+1;
archsim=zeros(archsize,L);

pini=ones(nst,1)/nst;

% 1b. simulate from q 

'1.a: simulate q'


comp=[1:M]';
qnormarch=zeros(MMC,1);

'simulation aus q'

mu = simuni(MMC,L);  

for m=1:MMC
   %   '1.a'
   m;
   index=mu==m;
   lm = sum(mu==m);
   if lm>0  %keine simulation, wenn m.te component nicht ausgesucht wurde
      qnorm=0;
      while qnorm==0
         [archq qnorm] = simqarch(march,squeeze(archpostm(:,m)),squeeze(archpostchol(:,:,m)),lm);
         if qnorm==0  
           % qnorm=0 wenn alle simulierten werte die bedingungen  verletzen,
           %  waehle zufllig eine andere komponente 
            mneu=simuni(MMC,1);  
            archpostm(:,m)= archpostm(:,mneu); 
            archpostchol(:,:,m)= archpostchol(:,:,mneu); 
            etapost(:,:,m)=etapost(:,:,mneu);
            betapostm(:,m)= betapostm(:,mneu);
            betapostchol(:,:,m)=betapostchol(:,:,mneu);
         end   
      end 
      qnormarch(m)=log(qnorm);
      archsim(:,mu==m) = archq;
      betasim(:,mu==m) = squeeze(betapostm(:,ones(1,lm)*m)) + squeeze(betapostchol(:,:,m))*randn(betasize,lm);
   end
   
end   

if nst>1
for ic=1:nst
   gam = gamrnd(squeeze(etapost(ic,:,mu)),ones(nst,L));   
   sumgam =  sum(gam,1);
   etasim(ic,:,:) =  gam./ sumgam(ones(1,nst),:);
end
end


loglikq=zeros(L,1);
%loglikmc=zeros(L,1);
priorq=zeros(L,1);
priormc=zeros(L,1);


% parameter der mixture prior bestimmen

pi=perms(1:nst);
nmix=size(pi,1);
prgamma1=zeros(nst,2,nmix);
e01=zeros(nst,nst,nmix);

for ml=1:nmix
   e01(:,:,ml)=e0(pi(ml,:),pi(ml,:));
   prgamma1(:,:,ml)=prgamma(pi(ml,:),:);
end   



for m=1:L
   
 % evaluate likelihood 
 %
 [fv loglikq(m)] = filtvertbetalev(y,Z,squeeze(etasim(:,:,m)),pini,archsim(1:march,m),archsim(march+1:end-1,m),archsim(end,m),betasim(:,m));
  
  
  %evaluate prior
  
  fq = prodinvgamlog(archsim(march+1:end-1,m*ones(1,nmix)),prgamma1)';
  if nst>1
  fq = fq+squeeze(dirichlog(etasim(:,:,m*ones(1,nmix)),e01));
  end
  fmax=max(fq);
  fq=fmax + log(mean(exp(fq-fmax)));
  
  alxiarg = [archsim(1:march,m);archsim(end,m)/2;1-sum(archsim(1:march,m),1)-0.5*archsim(end,m)];
  priorq(m)=priorq(m)+fq+log(0.5)+dirichlog(alxiarg',alxi0)+ pmultnormlog(betasim(:,m),prbem,prbeinf);
  
  fmc = prodinvgamlog(gammamcmc(:,m*ones(1,nmix)),prgamma1)';
  if nst>1
  fmc = fmc+squeeze(dirichlog(etamcmc(:,:,m*ones(1,nmix)),e01));
  end
  fmax=max(fmc);
  fmc=fmax + log(mean(exp(fmc-fmax)));
  alxiarg = [alphamcmc(:,m);ximcmc(m)/2;1-sum(alphamcmc(:,m),1)-0.5*ximcmc(m)];
  priormc(m)=priormc(m)+fmc+log(0.5)+dirichlog(alxiarg',alxi0)+ pmultnormlog(betamcmc(:,m),prbem,prbeinf);
 %%%%%%
 
   end   
   
   archmcmc=[alphamcmc;gammamcmc;ximcmc];
   [qq,qmc] = evalq(betasim,etasim,archsim,betamcmc,etamcmc,archmcmc,etapost,betapostm,betapostchol,archpostm,archpostchol,qnormarch);

